/*
eslint
jsdoc/require-jsdoc: off,
@typescript-eslint/no-empty-interface: off
*/
import bindings from 'bindings'

// TODO(Brett19): Check which of these is actually needed...
export type CppMilliseconds = number
export type CppSeconds = number
export type CppBytes = string | Buffer
export type CppDocFlags = number
export type CppExpiry = number
export type CppMutationState = CppMutationToken[]

export type CppJsonString = string

export interface CppDocumentId {
  bucket: string
  scope: string
  collection: string
  key: string
}

export interface CppCas {
  toString(): string
  toJSON(): any
}

export const zeroCas = 0 as any as CppCas

export interface CppMutationToken {
  toString(): string
  toJSON(): any
}

//#region Autogenerated Bindings

export enum CppManagementAnalyticsCouchbaseLinkEncryptionLevel {}
export enum CppManagementClusterBucketType {}
export enum CppManagementClusterBucketCompression {}
export enum CppManagementClusterBucketEvictionPolicy {}
export enum CppManagementClusterBucketConflictResolution {}
export enum CppManagementClusterBucketStorageBackend {}
export enum CppManagementEventingFunctionDcpBoundary {}
export enum CppManagementEventingFunctionLanguageCompatibility {}
export enum CppManagementEventingFunctionLogLevel {}
export enum CppManagementEventingFunctionBucketAccess {}
export enum CppManagementEventingFunctionStatus {}
export enum CppManagementEventingFunctionDeploymentStatus {}
export enum CppManagementEventingFunctionProcessingStatus {}
export enum CppManagementRbacAuthDomain {}
export enum CppIoRetryReason {}
export enum CppProtocolSubdocOpcode {}
export enum CppProtocolMutateInRequestBodyStoreSemanticsType {}
export enum CppProtocolDurabilityLevel {}
export enum CppProtocolStatus {}
export enum CppErrorCommonErrc {}
export enum CppErrorKeyValueErrc {}
export enum CppErrorQueryErrc {}
export enum CppErrorAnalyticsErrc {}
export enum CppErrorSearchErrc {}
export enum CppErrorViewErrc {}
export enum CppErrorManagementErrc {}
export enum CppErrorFieldLevelEncryptionErrc {}
export enum CppErrorNetworkErrc {}
export enum CppAnalyticsScanConsistency {}
export enum CppDesignDocumentNamespace {}
export enum CppDiagClusterState {}
export enum CppDiagEndpointState {}
export enum CppDiagPingState {}
export enum CppQueryProfileMode {}
export enum CppQueryScanConsistency {}
export enum CppSearchHighlightStyle {}
export enum CppSearchScanConsistency {}
export enum CppServiceType {}
export enum CppViewScanConsistency {}
export enum CppViewSortOrder {}

export interface CppManagementAnalyticsDataset {
  name: string
  dataverse_name: string
  link_name: string
  bucket_name: string
}
export interface CppManagementAnalyticsIndex {
  name: string
  dataverse_name: string
  dataset_name: string
  is_primary: boolean
}
export interface CppManagementAnalyticsAzureBlobExternalLink {
  link_name: string
  dataverse: string
  connection_string?: string
  account_name?: string
  account_key?: string
  shared_access_signature?: string
  blob_endpoint?: string
  endpoint_suffix?: string
}
export interface CppManagementAnalyticsCouchbaseLinkEncryptionSettings {
  level: CppManagementAnalyticsCouchbaseLinkEncryptionLevel
  certificate?: string
  client_certificate?: string
  client_key?: string
}
export interface CppManagementAnalyticsCouchbaseRemoteLink {
  link_name: string
  dataverse: string
  hostname: string
  username?: string
  password?: string
  encryption: CppManagementAnalyticsCouchbaseLinkEncryptionSettings
}
export interface CppManagementAnalyticsS3ExternalLink {
  link_name: string
  dataverse: string
  access_key_id: string
  secret_access_key: string
  session_token?: string
  region: string
  service_endpoint?: string
}
export interface CppManagementClusterBucketSettings {
  name: string
  uuid: string
  bucket_type: CppManagementClusterBucketType
  ram_quota_mb: number
  max_expiry: number
  compression_mode: CppManagementClusterBucketCompression
  minimum_durability_level?: CppProtocolDurabilityLevel
  num_replicas: number
  replica_indexes: boolean
  flush_enabled: boolean
  eviction_policy: CppManagementClusterBucketEvictionPolicy
  conflict_resolution_type: CppManagementClusterBucketConflictResolution
  storage_backend: CppManagementClusterBucketStorageBackend
  capabilities: string[]
  nodes: CppManagementClusterBucketSettingsNode[]
}
export interface CppManagementClusterBucketSettingsNode {
  hostname: string
  status: string
  version: string
  services: string[]
  ports: { [key: string /*string*/]: number }
}
export interface CppManagementViewsDesignDocument {
  rev: string
  name: string
  ns: CppDesignDocumentNamespace
  views: { [key: string /*string*/]: CppManagementViewsDesignDocumentView }
}
export interface CppManagementViewsDesignDocumentView {
  name: string
  map?: string
  reduce?: string
}
export interface CppManagementEventingFunctionKeyspace {
  bucket: string
  scope?: string
  collection?: string
}
export interface CppManagementEventingFunctionSettings {
  cpp_worker_count?: number
  dcp_stream_boundary?: CppManagementEventingFunctionDcpBoundary
  description?: string
  deployment_status?: CppManagementEventingFunctionDeploymentStatus
  processing_status?: CppManagementEventingFunctionProcessingStatus
  log_level?: CppManagementEventingFunctionLogLevel
  language_compatibility?: CppManagementEventingFunctionLanguageCompatibility
  execution_timeout?: CppMilliseconds
  lcb_inst_capacity?: number
  lcb_retry_count?: number
  lcb_timeout?: CppMilliseconds
  query_consistency?: CppQueryScanConsistency
  num_timer_partitions?: number
  sock_batch_size?: number
  tick_duration?: CppMilliseconds
  timer_context_size?: number
  user_prefix?: string
  bucket_cache_size?: number
  bucket_cache_age?: CppMilliseconds
  curl_max_allowed_resp_size?: number
  query_prepare_all?: boolean
  worker_count?: number
  handler_headers: string[]
  handler_footers: string[]
  enable_app_log_rotation?: boolean
  app_log_dir?: string
  app_log_max_size?: number
  app_log_max_files?: number
  checkpoint_interval?: CppMilliseconds
}
export interface CppManagementEventingFunctionBucketBinding {
  alias: string
  name: CppManagementEventingFunctionKeyspace
  access: CppManagementEventingFunctionBucketAccess
}
export interface CppManagementEventingFunctionUrlNoAuth {}
export interface CppManagementEventingFunctionUrlAuthBasic {
  username: string
  password: string
}
export interface CppManagementEventingFunctionUrlAuthDigest {
  username: string
  password: string
}
export interface CppManagementEventingFunctionUrlAuthBearer {
  key: string
}
export interface CppManagementEventingFunctionUrlBinding {
  alias: string
  hostname: string
  allow_cookies: boolean
  validate_ssl_certificate: boolean
  auth:
    | CppManagementEventingFunctionUrlNoAuth
    | CppManagementEventingFunctionUrlAuthBasic
    | CppManagementEventingFunctionUrlAuthDigest
    | CppManagementEventingFunctionUrlAuthBearer
}
export interface CppManagementEventingFunctionConstantBinding {
  alias: string
  literal: string
}
export interface CppManagementEventingFunction {
  name: string
  code: string
  metadata_keyspace: CppManagementEventingFunctionKeyspace
  source_keyspace: CppManagementEventingFunctionKeyspace
  version?: string
  enforce_schema?: boolean
  handler_uuid?: number
  function_instance_id?: string
  bucket_bindings: CppManagementEventingFunctionBucketBinding[]
  url_bindings: CppManagementEventingFunctionUrlBinding[]
  constant_bindings: CppManagementEventingFunctionConstantBinding[]
  settings: CppManagementEventingFunctionSettings
}
export interface CppManagementEventingFunctionState {
  name: string
  status: CppManagementEventingFunctionStatus
  num_bootstrapping_nodes: number
  num_deployed_nodes: number
  deployment_status: CppManagementEventingFunctionDeploymentStatus
  processing_status: CppManagementEventingFunctionProcessingStatus
  redeploy_required?: boolean
}
export interface CppManagementEventingStatus {
  num_eventing_nodes: number
  functions: CppManagementEventingFunctionState[]
}
export interface CppManagementRbacRole {
  name: string
  bucket?: string
  scope?: string
  collection?: string
}
export interface CppManagementRbacRoleAndDescription {
  display_name: string
  description: string
}
export interface CppManagementRbacOrigin {
  type: string
  name?: string
}
export interface CppManagementRbacRoleAndOrigins {
  origins: CppManagementRbacOrigin[]
}
export interface CppManagementRbacUser {
  username: string
  display_name?: string
  groups: string[]
  roles: CppManagementRbacRole[]
  password?: string
}
export interface CppManagementRbacUserAndMetadata {
  domain: CppManagementRbacAuthDomain
  effective_roles: CppManagementRbacRoleAndOrigins[]
  password_changed?: string
  external_groups: string[]
}
export interface CppManagementRbacGroup {
  name: string
  description?: string
  roles: CppManagementRbacRole[]
  ldap_group_reference?: string
}
export interface CppManagementSearchIndex {
  uuid: string
  name: string
  type: string
  params_json: string
  source_uuid: string
  source_name: string
  source_type: string
  source_params_json: string
  plan_params_json: string
}
export interface CppManagementQueryIndex {
  is_primary: boolean
  name: string
  state: string
  type: string
  index_key: string[]
  partition?: string
  condition?: string
  bucket_name: string
  scope_name?: string
  collection_name?: string
}
export interface CppTopologyCollectionsManifest {
  id: number[]
  uid: number
  scopes: CppTopologyCollectionsManifestScope[]
}
export interface CppTopologyCollectionsManifestCollection {
  uid: number
  name: string
}
export interface CppTopologyCollectionsManifestScope {
  uid: number
  name: string
  collections: CppTopologyCollectionsManifestCollection[]
}
export interface CppProtocolLookupInRequestBodyLookupInSpecs {
  entries: CppProtocolLookupInRequestBodyLookupInSpecsEntry[]
}
export interface CppProtocolLookupInRequestBodyLookupInSpecsEntry {
  opcode: number
  flags: number
  path: string
  original_index: number
}
export interface CppProtocolMutateInRequestBodyMutateInSpecs {
  entries: CppProtocolMutateInRequestBodyMutateInSpecsEntry[]
}
export interface CppProtocolMutateInRequestBodyMutateInSpecsEntry {
  opcode: number
  flags: number
  path: string
  param: string
  original_index: number
}
export interface CppDiagEndpointDiagInfo {
  type: CppServiceType
  id: string
  last_activity?: CppMilliseconds
  remote: string
  local: string
  state: CppDiagEndpointState
  bucket?: string
  details?: string
}
export interface CppDiagDiagnosticsResult {
  id: string
  sdk: string
  services: { [key: string /*CppServiceType*/]: CppDiagEndpointDiagInfo[] }
  version: number
}
export interface CppDiagEndpointPingInfo {
  type: CppServiceType
  id: string
  latency: CppMilliseconds
  remote: string
  local: string
  state: CppDiagPingState
  bucket?: string
  error?: string
}
export interface CppDiagPingResult {
  id: string
  sdk: string
  services: { [key: string /*CppServiceType*/]: CppDiagEndpointPingInfo[] }
  version: number
}
export interface CppPrependResponse {
  // ctx
  cas: CppCas
  token: CppMutationToken
}
export interface CppPrependRequest {
  id: CppDocumentId
  value: string
  partition: number
  opaque: number
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
}
export interface CppExistsResponse {
  // ctx
  deleted: boolean
  cas: CppCas
  flags: number
  expiry: number
  sequence_number: number
  datatype: number
}
export interface CppExistsRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  timeout?: CppMilliseconds
  // retries
}
export interface CppHttpNoopResponse {
  // ctx
}
export interface CppHttpNoopRequest {
  type: CppServiceType
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppUnlockResponse {
  // ctx
  cas: CppCas
}
export interface CppUnlockRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  cas: CppCas
  timeout?: CppMilliseconds
  // retries
}
export interface CppUpsertResponse {
  // ctx
  cas: CppCas
  token: CppMutationToken
}
export interface CppUpsertRequest {
  id: CppDocumentId
  value: string
  partition: number
  opaque: number
  flags: number
  expiry: number
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
  preserve_expiry: boolean
}
export interface CppAppendResponse {
  // ctx
  cas: CppCas
  token: CppMutationToken
}
export interface CppAppendRequest {
  id: CppDocumentId
  value: string
  partition: number
  opaque: number
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
}
export interface CppQueryResponse {
  // ctx
  meta: CppQueryResponseQueryMetaData
  prepared?: string
  rows: string[]
  served_by_node: string
}
export interface CppQueryResponseQueryMetrics {
  elapsed_time: CppMilliseconds
  execution_time: CppMilliseconds
  result_count: number
  result_size: number
  sort_count: number
  mutation_count: number
  error_count: number
  warning_count: number
}
export interface CppQueryResponseQueryProblem {
  code: number
  message: string
  reason?: number
  retry?: boolean
}
export interface CppQueryResponseQueryMetaData {
  request_id: string
  client_context_id: string
  status: string
  metrics?: CppQueryResponseQueryMetrics
  signature?: string
  profile?: string
  warnings?: CppQueryResponseQueryProblem[]
  errors?: CppQueryResponseQueryProblem[]
}
export interface CppQueryRequest {
  statement: string
  adhoc: boolean
  metrics: boolean
  readonly: boolean
  flex_index: boolean
  preserve_expiry: boolean
  max_parallelism?: number
  scan_cap?: number
  scan_wait?: CppMilliseconds
  pipeline_batch?: number
  pipeline_cap?: number
  scan_consistency?: CppQueryScanConsistency
  mutation_state: CppMutationToken[]
  bucket_name?: string
  scope_name?: string
  scope_qualifier?: string
  client_context_id?: string
  timeout?: CppMilliseconds
  profile: CppQueryProfileMode
  raw: { [key: string /*string*/]: CppJsonString }
  positional_parameters: CppJsonString[]
  named_parameters: { [key: string /*string*/]: CppJsonString }
  // row_callback
  send_to_node?: string
  // ctx_
  // extract_encoded_plan_
  body_str: string
}
export interface CppMcbpNoopResponse {
  // ctx
}
export interface CppReplaceResponse {
  // ctx
  cas: CppCas
  token: CppMutationToken
}
export interface CppReplaceRequest {
  id: CppDocumentId
  value: string
  partition: number
  opaque: number
  flags: number
  expiry: number
  cas: CppCas
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
  preserve_expiry: boolean
}
export interface CppGetAndTouchResponse {
  // ctx
  value: string
  cas: CppCas
  flags: number
}
export interface CppGetAndTouchRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  expiry: number
  timeout?: CppMilliseconds
  // retries
}
export interface CppRemoveResponse {
  // ctx
  cas: CppCas
  token: CppMutationToken
}
export interface CppRemoveRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  cas: CppCas
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
}
export interface CppGetResponse {
  // ctx
  value: string
  cas: CppCas
  flags: number
}
export interface CppGetRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  timeout?: CppMilliseconds
  // retries
}
export interface CppAnalyticsResponse {
  // ctx
  meta: CppAnalyticsResponseAnalyticsMetaData
  rows: string[]
}
export interface CppAnalyticsResponseAnalyticsMetrics {
  elapsed_time: CppMilliseconds
  execution_time: CppMilliseconds
  result_count: number
  result_size: number
  error_count: number
  processed_objects: number
  warning_count: number
}
export interface CppAnalyticsResponseAnalyticsProblem {
  code: number
  message: string
}
export interface CppAnalyticsResponseAnalyticsMetaData {
  request_id: string
  client_context_id: string
  status: string
  metrics: CppAnalyticsResponseAnalyticsMetrics
  signature?: string
  errors: CppAnalyticsResponseAnalyticsProblem[]
  warnings: CppAnalyticsResponseAnalyticsProblem[]
}
export interface CppAnalyticsRequest {
  statement: string
  readonly: boolean
  priority: boolean
  bucket_name?: string
  scope_name?: string
  scope_qualifier?: string
  scan_consistency?: CppAnalyticsScanConsistency
  raw: { [key: string /*string*/]: CppJsonString }
  positional_parameters: CppJsonString[]
  named_parameters: { [key: string /*string*/]: CppJsonString }
  // row_callback
  client_context_id?: string
  timeout?: CppMilliseconds
  body_str: string
}
export interface CppGetProjectedResponse {
  // ctx
  value: string
  cas: CppCas
  flags: number
  expiry?: number
}
export interface CppGetProjectedRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  projections: string[]
  with_expiry: boolean
  effective_projections: string[]
  preserve_array_indexes: boolean
  timeout?: CppMilliseconds
  // retries
}
export interface CppDecrementResponse {
  // ctx
  content: number
  cas: CppCas
  token: CppMutationToken
}
export interface CppDecrementRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  expiry: number
  delta: number
  initial_value?: number
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
  preserve_expiry: boolean
}
export interface CppSearchResponse {
  // ctx
  status: string
  meta: CppSearchResponseSearchMetaData
  error: string
  rows: CppSearchResponseSearchRow[]
  facets: CppSearchResponseSearchFacet[]
}
export interface CppSearchResponseSearchMetrics {
  took: CppMilliseconds
  total_rows: number
  max_score: number
  success_partition_count: number
  error_partition_count: number
}
export interface CppSearchResponseSearchMetaData {
  client_context_id: string
  metrics: CppSearchResponseSearchMetrics
  errors: { [key: string /*string*/]: string }
}
export interface CppSearchResponseSearchLocation {
  field: string
  term: string
  position: number
  start_offset: number
  end_offset: number
  array_positions?: number[]
}
export interface CppSearchResponseSearchRow {
  index: string
  id: string
  score: number
  locations: CppSearchResponseSearchLocation[]
  fragments: { [key: string /*string*/]: string[] }
  fields: string
  explanation: string
}
export interface CppSearchResponseSearchFacet {
  name: string
  field: string
  total: number
  missing: number
  other: number
  terms: CppSearchResponseSearchFacetTermFacet[]
  date_ranges: CppSearchResponseSearchFacetDateRangeFacet[]
  numeric_ranges: CppSearchResponseSearchFacetNumericRangeFacet[]
}
export interface CppSearchResponseSearchFacetTermFacet {
  term: string
  count: number
}
export interface CppSearchResponseSearchFacetDateRangeFacet {
  name: string
  count: number
  start?: string
  end?: string
}
export interface CppSearchResponseSearchFacetNumericRangeFacet {
  name: string
  count: number
  min: undefined | number | number
  max: undefined | number | number
}
export interface CppSearchRequest {
  index_name: string
  query: CppJsonString
  limit?: number
  skip?: number
  explain: boolean
  disable_scoring: boolean
  include_locations: boolean
  highlight_style?: CppSearchHighlightStyle
  highlight_fields: string[]
  fields: string[]
  scope_name?: string
  collections: string[]
  scan_consistency?: CppSearchScanConsistency
  mutation_state: CppMutationToken[]
  sort_specs: string[]
  facets: { [key: string /*string*/]: string }
  raw: { [key: string /*string*/]: CppJsonString }
  // row_callback
  client_context_id?: string
  timeout?: CppMilliseconds
  body_str: string
}
export interface CppTouchResponse {
  // ctx
  cas: CppCas
}
export interface CppTouchRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  expiry: number
  timeout?: CppMilliseconds
  // retries
}
export interface CppLookupInResponse {
  // ctx
  cas: CppCas
  fields: CppLookupInResponseField[]
  deleted: boolean
}
export interface CppLookupInResponseField {
  opcode: CppProtocolSubdocOpcode
  exists: boolean
  status: CppProtocolStatus
  path: string
  value: string
  original_index: number
  ec: CppError
}
export interface CppLookupInRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  access_deleted: boolean
  specs: CppProtocolLookupInRequestBodyLookupInSpecs
  timeout?: CppMilliseconds
  // retries
}
export interface CppDocumentViewResponse {
  // ctx
  meta: CppDocumentViewResponseMetaData
  rows: CppDocumentViewResponseRow[]
  error?: CppDocumentViewResponseProblem
}
export interface CppDocumentViewResponseMetaData {
  total_rows?: number
  debug_info?: string
}
export interface CppDocumentViewResponseRow {
  id?: string
  key: string
  value: string
}
export interface CppDocumentViewResponseProblem {
  code: string
  message: string
}
export interface CppDocumentViewRequest {
  bucket_name: string
  document_name: string
  view_name: string
  ns: CppDesignDocumentNamespace
  limit?: number
  skip?: number
  consistency?: CppViewScanConsistency
  keys: string[]
  key?: string
  start_key?: string
  end_key?: string
  start_key_doc_id?: string
  end_key_doc_id?: string
  inclusive_end?: boolean
  reduce?: boolean
  group?: boolean
  group_level?: number
  debug: boolean
  order?: CppViewSortOrder
  query_string: string[]
  // row_callback
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppGetAndLockResponse {
  // ctx
  value: string
  cas: CppCas
  flags: number
}
export interface CppGetAndLockRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  lock_time: number
  timeout?: CppMilliseconds
  // retries
}
export interface CppInsertResponse {
  // ctx
  cas: CppCas
  token: CppMutationToken
}
export interface CppInsertRequest {
  id: CppDocumentId
  value: string
  partition: number
  opaque: number
  flags: number
  expiry: number
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
}
export interface CppMutateInResponse {
  // ctx
  cas: CppCas
  token: CppMutationToken
  fields: CppMutateInResponseField[]
  first_error_index?: number
  deleted: boolean
}
export interface CppMutateInResponseField {
  opcode: CppProtocolSubdocOpcode
  status: CppProtocolStatus
  path: string
  value: string
  original_index: number
  ec: CppError
}
export interface CppMutateInRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  cas: CppCas
  access_deleted: boolean
  create_as_deleted: boolean
  expiry?: number
  store_semantics: CppProtocolMutateInRequestBodyStoreSemanticsType
  specs: CppProtocolMutateInRequestBodyMutateInSpecs
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
  preserve_expiry: boolean
}
export interface CppIncrementResponse {
  // ctx
  content: number
  cas: CppCas
  token: CppMutationToken
}
export interface CppIncrementRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  expiry: number
  delta: number
  initial_value?: number
  durability_level: CppProtocolDurabilityLevel
  timeout?: CppMilliseconds
  // retries
  preserve_expiry: boolean
}
export interface CppManagementGroupUpsertResponse {
  // ctx
  errors: string[]
}
export interface CppManagementGroupUpsertRequest {
  group: CppManagementRbacGroup
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingPauseFunctionResponse {
  // ctx
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingPauseFunctionRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementQueryIndexGetAllResponse {
  // ctx
  status: string
  indexes: CppManagementQueryIndex[]
}
export interface CppManagementQueryIndexGetAllRequest {
  bucket_name: string
  scope_name: string
  collection_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementCollectionCreateResponse {
  // ctx
  uid: number
}
export interface CppManagementCollectionCreateRequest {
  bucket_name: string
  scope_name: string
  collection_name: string
  max_expiry: number
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingResumeFunctionResponse {
  // ctx
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingResumeFunctionRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexGetStatsResponse {
  // ctx
  status: string
  error: string
  stats: string
}
export interface CppManagementSearchIndexGetStatsRequest {
  index_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementBucketGetAllResponse {
  // ctx
  buckets: CppManagementClusterBucketSettings[]
}
export interface CppManagementBucketGetAllRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementQueryIndexBuildDeferredResponse {
  // ctx
  status: string
  errors: CppManagementQueryIndexBuildDeferredResponseQueryProblem[]
}
export interface CppManagementQueryIndexBuildDeferredResponseQueryProblem {
  code: number
  message: string
}
export interface CppManagementQueryIndexBuildDeferredRequest {
  bucket_name: string
  scope_name: string
  collection_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementClusterDescribeResponse {
  // ctx
  info: CppManagementClusterDescribeResponseClusterInfo
}
export interface CppManagementClusterDescribeResponseClusterInfo {
  nodes: CppManagementClusterDescribeResponseClusterInfoNode[]
  buckets: CppManagementClusterDescribeResponseClusterInfoBucket[]
  services: CppServiceType[]
}
export interface CppManagementClusterDescribeResponseClusterInfoNode {
  uuid: string
  otp_node: string
  status: string
  hostname: string
  os: string
  version: string
  services: string[]
}
export interface CppManagementClusterDescribeResponseClusterInfoBucket {
  uuid: string
  name: string
}
export interface CppManagementClusterDescribeRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexGetAllResponse {
  // ctx
  status: string
  impl_version: string
  indexes: CppManagementSearchIndex[]
}
export interface CppManagementSearchIndexGetAllRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexAnalyzeDocumentResponse {
  // ctx
  status: string
  error: string
  analysis: string
}
export interface CppManagementSearchIndexAnalyzeDocumentRequest {
  index_name: string
  encoded_document: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementQueryIndexDropResponse {
  // ctx
  status: string
  errors: CppManagementQueryIndexDropResponseQueryProblem[]
}
export interface CppManagementQueryIndexDropResponseQueryProblem {
  code: number
  message: string
}
export interface CppManagementQueryIndexDropRequest {
  bucket_name: string
  scope_name: string
  collection_name: string
  index_name: string
  is_primary: boolean
  ignore_if_does_not_exist: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsDatasetCreateResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsProblem[]
}
export interface CppManagementAnalyticsDatasetCreateRequest {
  dataverse_name: string
  dataset_name: string
  bucket_name: string
  condition?: string
  client_context_id?: string
  timeout?: CppMilliseconds
  ignore_if_exists: boolean
}
export interface CppManagementBucketFlushResponse {
  // ctx
}
export interface CppManagementBucketFlushRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsIndexDropResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsProblem[]
}
export interface CppManagementAnalyticsIndexDropRequest {
  dataverse_name: string
  dataset_name: string
  index_name: string
  ignore_if_does_not_exist: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementQueryIndexCreateResponse {
  // ctx
  status: string
  errors: CppManagementQueryIndexCreateResponseQueryProblem[]
}
export interface CppManagementQueryIndexCreateResponseQueryProblem {
  code: number
  message: string
}
export interface CppManagementQueryIndexCreateRequest {
  bucket_name: string
  scope_name: string
  collection_name: string
  index_name: string
  fields: string[]
  is_primary: boolean
  ignore_if_exists: boolean
  condition?: string
  deferred?: boolean
  num_replicas?: number
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexUpsertResponse {
  // ctx
  status: string
  error: string
}
export interface CppManagementSearchIndexUpsertRequest {
  index: CppManagementSearchIndex
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsDatasetGetAllResponse {
  // ctx
  status: string
  datasets: CppManagementAnalyticsDataset[]
  errors: CppManagementAnalyticsProblem[]
}
export interface CppManagementAnalyticsDatasetGetAllRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsIndexGetAllResponse {
  // ctx
  status: string
  indexes: CppManagementAnalyticsIndex[]
  errors: CppManagementAnalyticsProblem[]
}
export interface CppManagementAnalyticsIndexGetAllRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsGetPendingMutationsResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsProblem[]
  stats: { [key: string /*string*/]: number }
}
export interface CppManagementAnalyticsGetPendingMutationsRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsDataverseDropResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsProblem[]
}
export interface CppManagementAnalyticsDataverseDropRequest {
  dataverse_name: string
  ignore_if_does_not_exist: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingProblem {
  code: number
  name: string
  description: string
}
export interface CppManagementAnalyticsLinkConnectResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsLinkConnectResponseProblem[]
}
export interface CppManagementAnalyticsLinkConnectResponseProblem {
  code: number
  message: string
}
export interface CppManagementAnalyticsLinkConnectRequest {
  dataverse_name: string
  link_name: string
  force: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementCollectionsManifestGetResponse {
  // ctx
  manifest: CppTopologyCollectionsManifest
}
export interface CppManagementCollectionsManifestGetRequest {
  id: CppDocumentId
  partition: number
  opaque: number
  timeout?: CppMilliseconds
  // retries
}
export interface CppManagementClusterDeveloperPreviewEnableResponse {
  // ctx
}
export interface CppManagementClusterDeveloperPreviewEnableRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsLinkDropResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsLinkDropResponseProblem[]
}
export interface CppManagementAnalyticsLinkDropResponseProblem {
  code: number
  message: string
}
export interface CppManagementAnalyticsLinkDropRequest {
  link_name: string
  dataverse_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementBucketDescribeResponse {
  // ctx
  info: CppManagementBucketDescribeResponseBucketInfo
}
export interface CppManagementBucketDescribeResponseBucketInfo {
  name: string
  uuid: string
  number_of_nodes: number
  number_of_replicas: number
  storage_backend: CppManagementClusterBucketStorageBackend
}
export interface CppManagementBucketDescribeRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingUpsertFunctionResponse {
  // ctx
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingUpsertFunctionRequest {
  function: CppManagementEventingFunction
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementViewIndexGetAllResponse {
  // ctx
  design_documents: CppManagementViewsDesignDocument[]
}
export interface CppManagementViewIndexGetAllRequest {
  bucket_name: string
  ns: CppDesignDocumentNamespace
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementBucketGetResponse {
  // ctx
  bucket: CppManagementClusterBucketSettings
}
export interface CppManagementBucketGetRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementBucketUpdateResponse {
  // ctx
  bucket: CppManagementClusterBucketSettings
  error_message: string
}
export interface CppManagementBucketUpdateRequest {
  bucket: CppManagementClusterBucketSettings
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementBucketDropResponse {
  // ctx
}
export interface CppManagementBucketDropRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementFreeformResponse {
  // ctx
  status: number
  headers: { [key: string /*string*/]: string }
  body: string
}
export interface CppManagementFreeformRequest {
  type: CppServiceType
  method: string
  path: string
  headers: { [key: string /*string*/]: string }
  body: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementScopeDropResponse {
  // ctx
  uid: number
}
export interface CppManagementScopeDropRequest {
  bucket_name: string
  scope_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementViewIndexUpsertResponse {
  // ctx
}
export interface CppManagementViewIndexUpsertRequest {
  bucket_name: string
  document: CppManagementViewsDesignDocument
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementUserGetAllResponse {
  // ctx
  users: CppManagementRbacUserAndMetadata[]
}
export interface CppManagementUserGetAllRequest {
  domain: CppManagementRbacAuthDomain
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementScopeCreateResponse {
  // ctx
  uid: number
}
export interface CppManagementScopeCreateRequest {
  bucket_name: string
  scope_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingGetFunctionResponse {
  // ctx
  function: CppManagementEventingFunction
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingGetFunctionRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementViewIndexDropResponse {
  // ctx
}
export interface CppManagementViewIndexDropRequest {
  bucket_name: string
  document_name: string
  ns: CppDesignDocumentNamespace
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsLinkReplaceResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsLinkReplaceResponseProblem[]
}
export interface CppManagementAnalyticsLinkReplaceResponseProblem {
  code: number
  message: string
}
export interface CppManagementAnalyticsLinkDisconnectResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsLinkDisconnectResponseProblem[]
}
export interface CppManagementAnalyticsLinkDisconnectResponseProblem {
  code: number
  message: string
}
export interface CppManagementAnalyticsLinkDisconnectRequest {
  dataverse_name: string
  link_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementUserUpsertResponse {
  // ctx
  errors: string[]
}
export interface CppManagementUserUpsertRequest {
  domain: CppManagementRbacAuthDomain
  user: CppManagementRbacUser
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingGetStatusResponse {
  // ctx
  status: CppManagementEventingStatus
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingGetStatusRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingGetAllFunctionsResponse {
  // ctx
  functions: CppManagementEventingFunction[]
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingGetAllFunctionsRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsIndexCreateResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsProblem[]
}
export interface CppManagementAnalyticsIndexCreateRequest {
  dataverse_name: string
  dataset_name: string
  index_name: string
  fields: { [key: string /*string*/]: string }
  ignore_if_exists: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementScopeGetAllResponse {
  // ctx
  manifest: CppTopologyCollectionsManifest
}
export interface CppManagementScopeGetAllRequest {
  bucket_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementUserGetResponse {
  // ctx
  user: CppManagementRbacUserAndMetadata
}
export interface CppManagementUserGetRequest {
  username: string
  domain: CppManagementRbacAuthDomain
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexDropResponse {
  // ctx
  status: string
  error: string
}
export interface CppManagementSearchIndexDropRequest {
  index_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexControlPlanFreezeResponse {
  // ctx
  status: string
  error: string
}
export interface CppManagementSearchIndexControlPlanFreezeRequest {
  index_name: string
  freeze: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexStatsResponse {
  // ctx
  stats: string
}
export interface CppManagementSearchIndexStatsRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementUserDropResponse {
  // ctx
}
export interface CppManagementUserDropRequest {
  username: string
  domain: CppManagementRbacAuthDomain
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsDataverseCreateResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsProblem[]
}
export interface CppManagementAnalyticsDataverseCreateRequest {
  dataverse_name: string
  ignore_if_exists: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexControlQueryResponse {
  // ctx
  status: string
  error: string
}
export interface CppManagementSearchIndexControlQueryRequest {
  index_name: string
  allow: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementRoleGetAllResponse {
  // ctx
  roles: CppManagementRbacRoleAndDescription[]
}
export interface CppManagementRoleGetAllRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementGroupGetAllResponse {
  // ctx
  groups: CppManagementRbacGroup[]
}
export interface CppManagementGroupGetAllRequest {
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsLinkCreateResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsLinkCreateResponseProblem[]
}
export interface CppManagementAnalyticsLinkCreateResponseProblem {
  code: number
  message: string
}
export interface CppManagementEventingDropFunctionResponse {
  // ctx
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingDropFunctionRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementCollectionDropResponse {
  // ctx
  uid: number
}
export interface CppManagementCollectionDropRequest {
  bucket_name: string
  scope_name: string
  collection_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsProblem {
  code: number
  message: string
}
export interface CppManagementSearchIndexControlIngestResponse {
  // ctx
  status: string
  error: string
}
export interface CppManagementSearchIndexControlIngestRequest {
  index_name: string
  pause: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingDeployFunctionResponse {
  // ctx
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingDeployFunctionRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementGroupGetResponse {
  // ctx
  group: CppManagementRbacGroup
}
export interface CppManagementGroupGetRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementViewIndexGetResponse {
  // ctx
  document: CppManagementViewsDesignDocument
}
export interface CppManagementViewIndexGetRequest {
  bucket_name: string
  document_name: string
  ns: CppDesignDocumentNamespace
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementBucketCreateResponse {
  // ctx
  error_message: string
}
export interface CppManagementBucketCreateRequest {
  bucket: CppManagementClusterBucketSettings
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsDatasetDropResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsProblem[]
}
export interface CppManagementAnalyticsDatasetDropRequest {
  dataverse_name: string
  dataset_name: string
  ignore_if_does_not_exist: boolean
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementGroupDropResponse {
  // ctx
}
export interface CppManagementGroupDropRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexGetResponse {
  // ctx
  status: string
  index: CppManagementSearchIndex
  error: string
}
export interface CppManagementSearchIndexGetRequest {
  index_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementEventingUndeployFunctionResponse {
  // ctx
  error?: CppManagementEventingProblem
}
export interface CppManagementEventingUndeployFunctionRequest {
  name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementSearchIndexGetDocumentsCountResponse {
  // ctx
  status: string
  count: number
  error: string
}
export interface CppManagementSearchIndexGetDocumentsCountRequest {
  index_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}
export interface CppManagementAnalyticsLinkGetAllResponse {
  // ctx
  status: string
  errors: CppManagementAnalyticsLinkGetAllResponseProblem[]
  couchbase: CppManagementAnalyticsCouchbaseRemoteLink[]
  s3: CppManagementAnalyticsS3ExternalLink[]
  azure_blob: CppManagementAnalyticsAzureBlobExternalLink[]
}
export interface CppManagementAnalyticsLinkGetAllResponseProblem {
  code: number
  message: string
}
export interface CppManagementAnalyticsLinkGetAllRequest {
  link_type: string
  link_name: string
  dataverse_name: string
  client_context_id?: string
  timeout?: CppMilliseconds
}

export interface CppConnectionAutogen {
  prepend(
    options: CppPrependRequest,
    callback: (err: CppError | null, result: CppPrependResponse) => void
  ): void
  exists(
    options: CppExistsRequest,
    callback: (err: CppError | null, result: CppExistsResponse) => void
  ): void
  httpNoop(
    options: CppHttpNoopRequest,
    callback: (err: CppError | null, result: CppHttpNoopResponse) => void
  ): void
  unlock(
    options: CppUnlockRequest,
    callback: (err: CppError | null, result: CppUnlockResponse) => void
  ): void
  upsert(
    options: CppUpsertRequest,
    callback: (err: CppError | null, result: CppUpsertResponse) => void
  ): void
  append(
    options: CppAppendRequest,
    callback: (err: CppError | null, result: CppAppendResponse) => void
  ): void
  query(
    options: CppQueryRequest,
    callback: (err: CppError | null, result: CppQueryResponse) => void
  ): void
  replace(
    options: CppReplaceRequest,
    callback: (err: CppError | null, result: CppReplaceResponse) => void
  ): void
  getAndTouch(
    options: CppGetAndTouchRequest,
    callback: (err: CppError | null, result: CppGetAndTouchResponse) => void
  ): void
  remove(
    options: CppRemoveRequest,
    callback: (err: CppError | null, result: CppRemoveResponse) => void
  ): void
  get(
    options: CppGetRequest,
    callback: (err: CppError | null, result: CppGetResponse) => void
  ): void
  analytics(
    options: CppAnalyticsRequest,
    callback: (err: CppError | null, result: CppAnalyticsResponse) => void
  ): void
  getProjected(
    options: CppGetProjectedRequest,
    callback: (err: CppError | null, result: CppGetProjectedResponse) => void
  ): void
  decrement(
    options: CppDecrementRequest,
    callback: (err: CppError | null, result: CppDecrementResponse) => void
  ): void
  search(
    options: CppSearchRequest,
    callback: (err: CppError | null, result: CppSearchResponse) => void
  ): void
  touch(
    options: CppTouchRequest,
    callback: (err: CppError | null, result: CppTouchResponse) => void
  ): void
  lookupIn(
    options: CppLookupInRequest,
    callback: (err: CppError | null, result: CppLookupInResponse) => void
  ): void
  documentView(
    options: CppDocumentViewRequest,
    callback: (err: CppError | null, result: CppDocumentViewResponse) => void
  ): void
  getAndLock(
    options: CppGetAndLockRequest,
    callback: (err: CppError | null, result: CppGetAndLockResponse) => void
  ): void
  insert(
    options: CppInsertRequest,
    callback: (err: CppError | null, result: CppInsertResponse) => void
  ): void
  mutateIn(
    options: CppMutateInRequest,
    callback: (err: CppError | null, result: CppMutateInResponse) => void
  ): void
  increment(
    options: CppIncrementRequest,
    callback: (err: CppError | null, result: CppIncrementResponse) => void
  ): void
  managementGroupUpsert(
    options: CppManagementGroupUpsertRequest,
    callback: (
      err: CppError | null,
      result: CppManagementGroupUpsertResponse
    ) => void
  ): void
  managementEventingPauseFunction(
    options: CppManagementEventingPauseFunctionRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingPauseFunctionResponse
    ) => void
  ): void
  managementQueryIndexGetAll(
    options: CppManagementQueryIndexGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementQueryIndexGetAllResponse
    ) => void
  ): void
  managementCollectionCreate(
    options: CppManagementCollectionCreateRequest,
    callback: (
      err: CppError | null,
      result: CppManagementCollectionCreateResponse
    ) => void
  ): void
  managementEventingResumeFunction(
    options: CppManagementEventingResumeFunctionRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingResumeFunctionResponse
    ) => void
  ): void
  managementSearchIndexGetStats(
    options: CppManagementSearchIndexGetStatsRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexGetStatsResponse
    ) => void
  ): void
  managementBucketGetAll(
    options: CppManagementBucketGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementBucketGetAllResponse
    ) => void
  ): void
  managementQueryIndexBuildDeferred(
    options: CppManagementQueryIndexBuildDeferredRequest,
    callback: (
      err: CppError | null,
      result: CppManagementQueryIndexBuildDeferredResponse
    ) => void
  ): void
  managementClusterDescribe(
    options: CppManagementClusterDescribeRequest,
    callback: (
      err: CppError | null,
      result: CppManagementClusterDescribeResponse
    ) => void
  ): void
  managementSearchIndexGetAll(
    options: CppManagementSearchIndexGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexGetAllResponse
    ) => void
  ): void
  managementSearchIndexAnalyzeDocument(
    options: CppManagementSearchIndexAnalyzeDocumentRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexAnalyzeDocumentResponse
    ) => void
  ): void
  managementQueryIndexDrop(
    options: CppManagementQueryIndexDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementQueryIndexDropResponse
    ) => void
  ): void
  managementAnalyticsDatasetCreate(
    options: CppManagementAnalyticsDatasetCreateRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsDatasetCreateResponse
    ) => void
  ): void
  managementBucketFlush(
    options: CppManagementBucketFlushRequest,
    callback: (
      err: CppError | null,
      result: CppManagementBucketFlushResponse
    ) => void
  ): void
  managementAnalyticsIndexDrop(
    options: CppManagementAnalyticsIndexDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsIndexDropResponse
    ) => void
  ): void
  managementQueryIndexCreate(
    options: CppManagementQueryIndexCreateRequest,
    callback: (
      err: CppError | null,
      result: CppManagementQueryIndexCreateResponse
    ) => void
  ): void
  managementSearchIndexUpsert(
    options: CppManagementSearchIndexUpsertRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexUpsertResponse
    ) => void
  ): void
  managementAnalyticsDatasetGetAll(
    options: CppManagementAnalyticsDatasetGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsDatasetGetAllResponse
    ) => void
  ): void
  managementAnalyticsIndexGetAll(
    options: CppManagementAnalyticsIndexGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsIndexGetAllResponse
    ) => void
  ): void
  managementAnalyticsGetPendingMutations(
    options: CppManagementAnalyticsGetPendingMutationsRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsGetPendingMutationsResponse
    ) => void
  ): void
  managementAnalyticsDataverseDrop(
    options: CppManagementAnalyticsDataverseDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsDataverseDropResponse
    ) => void
  ): void
  managementAnalyticsLinkConnect(
    options: CppManagementAnalyticsLinkConnectRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsLinkConnectResponse
    ) => void
  ): void
  managementCollectionsManifestGet(
    options: CppManagementCollectionsManifestGetRequest,
    callback: (
      err: CppError | null,
      result: CppManagementCollectionsManifestGetResponse
    ) => void
  ): void
  managementClusterDeveloperPreviewEnable(
    options: CppManagementClusterDeveloperPreviewEnableRequest,
    callback: (
      err: CppError | null,
      result: CppManagementClusterDeveloperPreviewEnableResponse
    ) => void
  ): void
  managementAnalyticsLinkDrop(
    options: CppManagementAnalyticsLinkDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsLinkDropResponse
    ) => void
  ): void
  managementBucketDescribe(
    options: CppManagementBucketDescribeRequest,
    callback: (
      err: CppError | null,
      result: CppManagementBucketDescribeResponse
    ) => void
  ): void
  managementEventingUpsertFunction(
    options: CppManagementEventingUpsertFunctionRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingUpsertFunctionResponse
    ) => void
  ): void
  managementViewIndexGetAll(
    options: CppManagementViewIndexGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementViewIndexGetAllResponse
    ) => void
  ): void
  managementBucketGet(
    options: CppManagementBucketGetRequest,
    callback: (
      err: CppError | null,
      result: CppManagementBucketGetResponse
    ) => void
  ): void
  managementBucketUpdate(
    options: CppManagementBucketUpdateRequest,
    callback: (
      err: CppError | null,
      result: CppManagementBucketUpdateResponse
    ) => void
  ): void
  managementBucketDrop(
    options: CppManagementBucketDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementBucketDropResponse
    ) => void
  ): void
  managementFreeform(
    options: CppManagementFreeformRequest,
    callback: (
      err: CppError | null,
      result: CppManagementFreeformResponse
    ) => void
  ): void
  managementScopeDrop(
    options: CppManagementScopeDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementScopeDropResponse
    ) => void
  ): void
  managementViewIndexUpsert(
    options: CppManagementViewIndexUpsertRequest,
    callback: (
      err: CppError | null,
      result: CppManagementViewIndexUpsertResponse
    ) => void
  ): void
  managementUserGetAll(
    options: CppManagementUserGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementUserGetAllResponse
    ) => void
  ): void
  managementScopeCreate(
    options: CppManagementScopeCreateRequest,
    callback: (
      err: CppError | null,
      result: CppManagementScopeCreateResponse
    ) => void
  ): void
  managementEventingGetFunction(
    options: CppManagementEventingGetFunctionRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingGetFunctionResponse
    ) => void
  ): void
  managementViewIndexDrop(
    options: CppManagementViewIndexDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementViewIndexDropResponse
    ) => void
  ): void
  managementAnalyticsLinkDisconnect(
    options: CppManagementAnalyticsLinkDisconnectRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsLinkDisconnectResponse
    ) => void
  ): void
  managementUserUpsert(
    options: CppManagementUserUpsertRequest,
    callback: (
      err: CppError | null,
      result: CppManagementUserUpsertResponse
    ) => void
  ): void
  managementEventingGetStatus(
    options: CppManagementEventingGetStatusRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingGetStatusResponse
    ) => void
  ): void
  managementEventingGetAllFunctions(
    options: CppManagementEventingGetAllFunctionsRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingGetAllFunctionsResponse
    ) => void
  ): void
  managementAnalyticsIndexCreate(
    options: CppManagementAnalyticsIndexCreateRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsIndexCreateResponse
    ) => void
  ): void
  managementScopeGetAll(
    options: CppManagementScopeGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementScopeGetAllResponse
    ) => void
  ): void
  managementUserGet(
    options: CppManagementUserGetRequest,
    callback: (
      err: CppError | null,
      result: CppManagementUserGetResponse
    ) => void
  ): void
  managementSearchIndexDrop(
    options: CppManagementSearchIndexDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexDropResponse
    ) => void
  ): void
  managementSearchIndexControlPlanFreeze(
    options: CppManagementSearchIndexControlPlanFreezeRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexControlPlanFreezeResponse
    ) => void
  ): void
  managementSearchIndexStats(
    options: CppManagementSearchIndexStatsRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexStatsResponse
    ) => void
  ): void
  managementUserDrop(
    options: CppManagementUserDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementUserDropResponse
    ) => void
  ): void
  managementAnalyticsDataverseCreate(
    options: CppManagementAnalyticsDataverseCreateRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsDataverseCreateResponse
    ) => void
  ): void
  managementSearchIndexControlQuery(
    options: CppManagementSearchIndexControlQueryRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexControlQueryResponse
    ) => void
  ): void
  managementRoleGetAll(
    options: CppManagementRoleGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementRoleGetAllResponse
    ) => void
  ): void
  managementGroupGetAll(
    options: CppManagementGroupGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementGroupGetAllResponse
    ) => void
  ): void
  managementEventingDropFunction(
    options: CppManagementEventingDropFunctionRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingDropFunctionResponse
    ) => void
  ): void
  managementCollectionDrop(
    options: CppManagementCollectionDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementCollectionDropResponse
    ) => void
  ): void
  managementSearchIndexControlIngest(
    options: CppManagementSearchIndexControlIngestRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexControlIngestResponse
    ) => void
  ): void
  managementEventingDeployFunction(
    options: CppManagementEventingDeployFunctionRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingDeployFunctionResponse
    ) => void
  ): void
  managementGroupGet(
    options: CppManagementGroupGetRequest,
    callback: (
      err: CppError | null,
      result: CppManagementGroupGetResponse
    ) => void
  ): void
  managementViewIndexGet(
    options: CppManagementViewIndexGetRequest,
    callback: (
      err: CppError | null,
      result: CppManagementViewIndexGetResponse
    ) => void
  ): void
  managementBucketCreate(
    options: CppManagementBucketCreateRequest,
    callback: (
      err: CppError | null,
      result: CppManagementBucketCreateResponse
    ) => void
  ): void
  managementAnalyticsDatasetDrop(
    options: CppManagementAnalyticsDatasetDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsDatasetDropResponse
    ) => void
  ): void
  managementGroupDrop(
    options: CppManagementGroupDropRequest,
    callback: (
      err: CppError | null,
      result: CppManagementGroupDropResponse
    ) => void
  ): void
  managementSearchIndexGet(
    options: CppManagementSearchIndexGetRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexGetResponse
    ) => void
  ): void
  managementEventingUndeployFunction(
    options: CppManagementEventingUndeployFunctionRequest,
    callback: (
      err: CppError | null,
      result: CppManagementEventingUndeployFunctionResponse
    ) => void
  ): void
  managementSearchIndexGetDocumentsCount(
    options: CppManagementSearchIndexGetDocumentsCountRequest,
    callback: (
      err: CppError | null,
      result: CppManagementSearchIndexGetDocumentsCountResponse
    ) => void
  ): void
  managementAnalyticsLinkGetAll(
    options: CppManagementAnalyticsLinkGetAllRequest,
    callback: (
      err: CppError | null,
      result: CppManagementAnalyticsLinkGetAllResponse
    ) => void
  ): void
}

export interface CppBindingAutogen {
  management_analytics_couchbase_link_encryption_level: {
    none: CppManagementAnalyticsCouchbaseLinkEncryptionLevel
    half: CppManagementAnalyticsCouchbaseLinkEncryptionLevel
    full: CppManagementAnalyticsCouchbaseLinkEncryptionLevel
  }
  management_cluster_bucket_type: {
    unknown: CppManagementClusterBucketType
    couchbase: CppManagementClusterBucketType
    memcached: CppManagementClusterBucketType
    ephemeral: CppManagementClusterBucketType
  }
  management_cluster_bucket_compression: {
    unknown: CppManagementClusterBucketCompression
    off: CppManagementClusterBucketCompression
    active: CppManagementClusterBucketCompression
    passive: CppManagementClusterBucketCompression
  }
  management_cluster_bucket_eviction_policy: {
    unknown: CppManagementClusterBucketEvictionPolicy
    full: CppManagementClusterBucketEvictionPolicy
    value_only: CppManagementClusterBucketEvictionPolicy
    no_eviction: CppManagementClusterBucketEvictionPolicy
    not_recently_used: CppManagementClusterBucketEvictionPolicy
  }
  management_cluster_bucket_conflict_resolution: {
    unknown: CppManagementClusterBucketConflictResolution
    timestamp: CppManagementClusterBucketConflictResolution
    sequence_number: CppManagementClusterBucketConflictResolution
    custom: CppManagementClusterBucketConflictResolution
  }
  management_cluster_bucket_storage_backend: {
    unknown: CppManagementClusterBucketStorageBackend
    couchstore: CppManagementClusterBucketStorageBackend
    magma: CppManagementClusterBucketStorageBackend
  }
  management_eventing_function_dcp_boundary: {
    everything: CppManagementEventingFunctionDcpBoundary
    from_now: CppManagementEventingFunctionDcpBoundary
  }
  management_eventing_function_language_compatibility: {
    version_6_0_0: CppManagementEventingFunctionLanguageCompatibility
    version_6_5_0: CppManagementEventingFunctionLanguageCompatibility
    version_6_6_2: CppManagementEventingFunctionLanguageCompatibility
  }
  management_eventing_function_log_level: {
    info: CppManagementEventingFunctionLogLevel
    error: CppManagementEventingFunctionLogLevel
    warning: CppManagementEventingFunctionLogLevel
    debug: CppManagementEventingFunctionLogLevel
    trace: CppManagementEventingFunctionLogLevel
  }
  management_eventing_function_bucket_access: {
    read_only: CppManagementEventingFunctionBucketAccess
    read_write: CppManagementEventingFunctionBucketAccess
  }
  management_eventing_function_status: {
    undeployed: CppManagementEventingFunctionStatus
    undeploying: CppManagementEventingFunctionStatus
    deploying: CppManagementEventingFunctionStatus
    deployed: CppManagementEventingFunctionStatus
    paused: CppManagementEventingFunctionStatus
    pausing: CppManagementEventingFunctionStatus
  }
  management_eventing_function_deployment_status: {
    deployed: CppManagementEventingFunctionDeploymentStatus
    undeployed: CppManagementEventingFunctionDeploymentStatus
  }
  management_eventing_function_processing_status: {
    running: CppManagementEventingFunctionProcessingStatus
    paused: CppManagementEventingFunctionProcessingStatus
  }
  management_rbac_auth_domain: {
    unknown: CppManagementRbacAuthDomain
    local: CppManagementRbacAuthDomain
    external: CppManagementRbacAuthDomain
  }
  io_retry_reason: {
    do_not_retry: CppIoRetryReason
    unknown: CppIoRetryReason
    socket_not_available: CppIoRetryReason
    service_not_available: CppIoRetryReason
    node_not_available: CppIoRetryReason
    kv_not_my_vbucket: CppIoRetryReason
    kv_collection_outdated: CppIoRetryReason
    kv_error_map_retry_indicated: CppIoRetryReason
    kv_locked: CppIoRetryReason
    kv_temporary_failure: CppIoRetryReason
    kv_sync_write_in_progress: CppIoRetryReason
    kv_sync_write_re_commit_in_progress: CppIoRetryReason
    service_response_code_indicated: CppIoRetryReason
    socket_closed_while_in_flight: CppIoRetryReason
    circuit_breaker_open: CppIoRetryReason
    query_prepared_statement_failure: CppIoRetryReason
    query_index_not_found: CppIoRetryReason
    analytics_temporary_failure: CppIoRetryReason
    search_too_many_requests: CppIoRetryReason
    views_temporary_failure: CppIoRetryReason
    views_no_active_partition: CppIoRetryReason
  }
  protocol_subdoc_opcode: {
    get_doc: CppProtocolSubdocOpcode
    set_doc: CppProtocolSubdocOpcode
    remove_doc: CppProtocolSubdocOpcode
    get: CppProtocolSubdocOpcode
    exists: CppProtocolSubdocOpcode
    dict_add: CppProtocolSubdocOpcode
    dict_upsert: CppProtocolSubdocOpcode
    remove: CppProtocolSubdocOpcode
    replace: CppProtocolSubdocOpcode
    array_push_last: CppProtocolSubdocOpcode
    array_push_first: CppProtocolSubdocOpcode
    array_insert: CppProtocolSubdocOpcode
    array_add_unique: CppProtocolSubdocOpcode
    counter: CppProtocolSubdocOpcode
    get_count: CppProtocolSubdocOpcode
    replace_body_with_xattr: CppProtocolSubdocOpcode
  }
  protocol_mutate_in_request_body_store_semantics_type: {
    replace: CppProtocolMutateInRequestBodyStoreSemanticsType
    upsert: CppProtocolMutateInRequestBodyStoreSemanticsType
    insert: CppProtocolMutateInRequestBodyStoreSemanticsType
  }
  protocol_durability_level: {
    none: CppProtocolDurabilityLevel
    majority: CppProtocolDurabilityLevel
    majority_and_persist_to_active: CppProtocolDurabilityLevel
    persist_to_majority: CppProtocolDurabilityLevel
  }
  protocol_status: {
    success: CppProtocolStatus
    not_found: CppProtocolStatus
    exists: CppProtocolStatus
    too_big: CppProtocolStatus
    invalid: CppProtocolStatus
    not_stored: CppProtocolStatus
    delta_bad_value: CppProtocolStatus
    not_my_vbucket: CppProtocolStatus
    no_bucket: CppProtocolStatus
    dcp_stream_not_found: CppProtocolStatus
    opaque_no_match: CppProtocolStatus
    locked: CppProtocolStatus
    auth_stale: CppProtocolStatus
    auth_error: CppProtocolStatus
    auth_continue: CppProtocolStatus
    range_error: CppProtocolStatus
    rollback: CppProtocolStatus
    no_access: CppProtocolStatus
    not_initialized: CppProtocolStatus
    rate_limited_network_ingress: CppProtocolStatus
    rate_limited_network_egress: CppProtocolStatus
    rate_limited_max_connections: CppProtocolStatus
    rate_limited_max_commands: CppProtocolStatus
    scope_size_limit_exceeded: CppProtocolStatus
    unknown_frame_info: CppProtocolStatus
    unknown_command: CppProtocolStatus
    no_memory: CppProtocolStatus
    not_supported: CppProtocolStatus
    internal: CppProtocolStatus
    busy: CppProtocolStatus
    temporary_failure: CppProtocolStatus
    xattr_invalid: CppProtocolStatus
    unknown_collection: CppProtocolStatus
    no_collections_manifest: CppProtocolStatus
    cannot_apply_collections_manifest: CppProtocolStatus
    collections_manifest_is_ahead: CppProtocolStatus
    unknown_scope: CppProtocolStatus
    dcp_stream_id_invalid: CppProtocolStatus
    durability_invalid_level: CppProtocolStatus
    durability_impossible: CppProtocolStatus
    sync_write_in_progress: CppProtocolStatus
    sync_write_ambiguous: CppProtocolStatus
    sync_write_re_commit_in_progress: CppProtocolStatus
    subdoc_path_not_found: CppProtocolStatus
    subdoc_path_mismatch: CppProtocolStatus
    subdoc_path_invalid: CppProtocolStatus
    subdoc_path_too_big: CppProtocolStatus
    subdoc_doc_too_deep: CppProtocolStatus
    subdoc_value_cannot_insert: CppProtocolStatus
    subdoc_doc_not_json: CppProtocolStatus
    subdoc_num_range_error: CppProtocolStatus
    subdoc_delta_invalid: CppProtocolStatus
    subdoc_path_exists: CppProtocolStatus
    subdoc_value_too_deep: CppProtocolStatus
    subdoc_invalid_combo: CppProtocolStatus
    subdoc_multi_path_failure: CppProtocolStatus
    subdoc_success_deleted: CppProtocolStatus
    subdoc_xattr_invalid_flag_combo: CppProtocolStatus
    subdoc_xattr_invalid_key_combo: CppProtocolStatus
    subdoc_xattr_unknown_macro: CppProtocolStatus
    subdoc_xattr_unknown_vattr: CppProtocolStatus
    subdoc_xattr_cannot_modify_vattr: CppProtocolStatus
    subdoc_multi_path_failure_deleted: CppProtocolStatus
    subdoc_invalid_xattr_order: CppProtocolStatus
    subdoc_xattr_unknown_vattr_macro: CppProtocolStatus
    subdoc_can_only_revive_deleted_documents: CppProtocolStatus
    subdoc_deleted_document_cannot_have_value: CppProtocolStatus
  }
  error_common_errc: {
    request_canceled: CppErrorCommonErrc
    invalid_argument: CppErrorCommonErrc
    service_not_available: CppErrorCommonErrc
    internal_server_failure: CppErrorCommonErrc
    authentication_failure: CppErrorCommonErrc
    temporary_failure: CppErrorCommonErrc
    parsing_failure: CppErrorCommonErrc
    cas_mismatch: CppErrorCommonErrc
    bucket_not_found: CppErrorCommonErrc
    collection_not_found: CppErrorCommonErrc
    unsupported_operation: CppErrorCommonErrc
    ambiguous_timeout: CppErrorCommonErrc
    unambiguous_timeout: CppErrorCommonErrc
    feature_not_available: CppErrorCommonErrc
    scope_not_found: CppErrorCommonErrc
    index_not_found: CppErrorCommonErrc
    index_exists: CppErrorCommonErrc
    encoding_failure: CppErrorCommonErrc
    decoding_failure: CppErrorCommonErrc
    rate_limited: CppErrorCommonErrc
    quota_limited: CppErrorCommonErrc
  }
  error_key_value_errc: {
    document_not_found: CppErrorKeyValueErrc
    document_irretrievable: CppErrorKeyValueErrc
    document_locked: CppErrorKeyValueErrc
    value_too_large: CppErrorKeyValueErrc
    document_exists: CppErrorKeyValueErrc
    durability_level_not_available: CppErrorKeyValueErrc
    durability_impossible: CppErrorKeyValueErrc
    durability_ambiguous: CppErrorKeyValueErrc
    durable_write_in_progress: CppErrorKeyValueErrc
    durable_write_re_commit_in_progress: CppErrorKeyValueErrc
    path_not_found: CppErrorKeyValueErrc
    path_mismatch: CppErrorKeyValueErrc
    path_invalid: CppErrorKeyValueErrc
    path_too_big: CppErrorKeyValueErrc
    path_too_deep: CppErrorKeyValueErrc
    value_too_deep: CppErrorKeyValueErrc
    value_invalid: CppErrorKeyValueErrc
    document_not_json: CppErrorKeyValueErrc
    number_too_big: CppErrorKeyValueErrc
    delta_invalid: CppErrorKeyValueErrc
    path_exists: CppErrorKeyValueErrc
    xattr_unknown_macro: CppErrorKeyValueErrc
    xattr_invalid_key_combo: CppErrorKeyValueErrc
    xattr_unknown_virtual_attribute: CppErrorKeyValueErrc
    xattr_cannot_modify_virtual_attribute: CppErrorKeyValueErrc
    xattr_no_access: CppErrorKeyValueErrc
    cannot_revive_living_document: CppErrorKeyValueErrc
  }
  error_query_errc: {
    planning_failure: CppErrorQueryErrc
    index_failure: CppErrorQueryErrc
    prepared_statement_failure: CppErrorQueryErrc
    dml_failure: CppErrorQueryErrc
  }
  error_analytics_errc: {
    compilation_failure: CppErrorAnalyticsErrc
    job_queue_full: CppErrorAnalyticsErrc
    dataset_not_found: CppErrorAnalyticsErrc
    dataverse_not_found: CppErrorAnalyticsErrc
    dataset_exists: CppErrorAnalyticsErrc
    dataverse_exists: CppErrorAnalyticsErrc
    link_not_found: CppErrorAnalyticsErrc
    link_exists: CppErrorAnalyticsErrc
  }
  error_search_errc: {
    index_not_ready: CppErrorSearchErrc
    consistency_mismatch: CppErrorSearchErrc
  }
  error_view_errc: {
    view_not_found: CppErrorViewErrc
    design_document_not_found: CppErrorViewErrc
  }
  error_management_errc: {
    collection_exists: CppErrorManagementErrc
    scope_exists: CppErrorManagementErrc
    user_not_found: CppErrorManagementErrc
    group_not_found: CppErrorManagementErrc
    bucket_exists: CppErrorManagementErrc
    user_exists: CppErrorManagementErrc
    bucket_not_flushable: CppErrorManagementErrc
    eventing_function_not_found: CppErrorManagementErrc
    eventing_function_not_deployed: CppErrorManagementErrc
    eventing_function_compilation_failure: CppErrorManagementErrc
    eventing_function_identical_keyspace: CppErrorManagementErrc
    eventing_function_not_bootstrapped: CppErrorManagementErrc
    eventing_function_deployed: CppErrorManagementErrc
    eventing_function_paused: CppErrorManagementErrc
  }
  error_field_level_encryption_errc: {
    generic_cryptography_failure: CppErrorFieldLevelEncryptionErrc
    encryption_failure: CppErrorFieldLevelEncryptionErrc
    decryption_failure: CppErrorFieldLevelEncryptionErrc
    crypto_key_not_found: CppErrorFieldLevelEncryptionErrc
    invalid_crypto_key: CppErrorFieldLevelEncryptionErrc
    decrypter_not_found: CppErrorFieldLevelEncryptionErrc
    encrypter_not_found: CppErrorFieldLevelEncryptionErrc
    invalid_ciphertext: CppErrorFieldLevelEncryptionErrc
  }
  error_network_errc: {
    resolve_failure: CppErrorNetworkErrc
    no_endpoints_left: CppErrorNetworkErrc
    handshake_failure: CppErrorNetworkErrc
    protocol_error: CppErrorNetworkErrc
    configuration_not_available: CppErrorNetworkErrc
    cluster_closed: CppErrorNetworkErrc
  }
  analytics_scan_consistency: {
    not_bounded: CppAnalyticsScanConsistency
    request_plus: CppAnalyticsScanConsistency
  }
  design_document_namespace: {
    development: CppDesignDocumentNamespace
    production: CppDesignDocumentNamespace
  }
  diag_cluster_state: {
    online: CppDiagClusterState
    degraded: CppDiagClusterState
    offline: CppDiagClusterState
  }
  diag_endpoint_state: {
    disconnected: CppDiagEndpointState
    connecting: CppDiagEndpointState
    connected: CppDiagEndpointState
    disconnecting: CppDiagEndpointState
  }
  diag_ping_state: {
    ok: CppDiagPingState
    timeout: CppDiagPingState
    error: CppDiagPingState
  }
  query_profile_mode: {
    off: CppQueryProfileMode
    phases: CppQueryProfileMode
    timings: CppQueryProfileMode
  }
  query_scan_consistency: {
    not_bounded: CppQueryScanConsistency
    request_plus: CppQueryScanConsistency
  }
  search_highlight_style: {
    html: CppSearchHighlightStyle
    ansi: CppSearchHighlightStyle
  }
  search_scan_consistency: {
    not_bounded: CppSearchScanConsistency
  }
  service_type: {
    key_value: CppServiceType
    query: CppServiceType
    analytics: CppServiceType
    search: CppServiceType
    view: CppServiceType
    management: CppServiceType
    eventing: CppServiceType
  }
  view_scan_consistency: {
    not_bounded: CppViewScanConsistency
    update_after: CppViewScanConsistency
    request_plus: CppViewScanConsistency
  }
  view_sort_order: {
    ascending: CppViewSortOrder
    descending: CppViewSortOrder
  }
}

//#endregion Autogenerated Bindings

export type CppErrc =
  | CppErrorCommonErrc
  | CppErrorKeyValueErrc
  | CppErrorQueryErrc
  | CppErrorAnalyticsErrc
  | CppErrorSearchErrc
  | CppErrorViewErrc
  | CppErrorManagementErrc
  | CppErrorFieldLevelEncryptionErrc
  | CppErrorNetworkErrc

export enum CppTxnFailureType {}
export enum CppTxnExternalException {}

// This type intentionally does not inherit from Error so that it will
// not be trivially castable to error and forces us to convert the errors.
export interface CppErrorBase {
  code: CppErrc
}

export interface CppGenericError extends CppErrorBase {
  ctxtype: undefined | null
}

export interface CppEnhancedErrorInfo {
  reference: string
  context: string
}

export interface CppKeyValueError extends CppErrorBase {
  ctxtype: 'key_value'
  id: CppDocumentId
  opaque: number
  cas: CppCas
  status_code: CppProtocolStatus
  enhanced_error_info: CppEnhancedErrorInfo
  last_dispatched_to: string
  last_dispatched_from: string
  retry_attempts: number
  retry_reasons: CppIoRetryReason[]
}

export interface CppViewError extends CppErrorBase {
  ctxtype: 'view'
  client_context_id: string
  design_document_name: string
  view_name: string
  query_string: string
  method: string
  path: string
  http_status: number
  http_body: string
  last_dispatched_to: string
  last_dispatched_from: string
  retry_attempts: number
  retry_reasons: CppIoRetryReason[]
}

export interface CppQueryError extends CppErrorBase {
  ctxtype: 'query'
  first_error_code: number
  first_error_message: string
  client_context_id: string
  statement: string
  parameters: string
  method: string
  path: string
  http_status: number
  http_body: string
  last_dispatched_to: string
  last_dispatched_from: string
  retry_attempts: number
  retry_reasons: CppIoRetryReason[]
}

export interface CppSearchError extends CppErrorBase {
  ctxtype: 'search'
  client_context_id: string
  index_name: string
  query: string
  parameters: string
  method: string
  path: string
  http_status: number
  http_body: string
  last_dispatched_to: string
  last_dispatched_from: string
  retry_attempts: number
  retry_reasons: CppIoRetryReason[]
}

export interface CppAnalyticsError extends CppErrorBase {
  ctxtype: 'analytics'
  first_error_code: number
  first_error_message: string
  client_context_id: string
  statement: string
  parameters: string
  method: string
  path: string
  http_status: number
  http_body: string
  last_dispatched_to: string
  last_dispatched_from: string
  retry_attempts: number
  retry_reasons: CppIoRetryReason[]
}

export interface CppHttpError extends CppErrorBase {
  ctxtype: 'http'
  client_context_id: string
  method: string
  path: string
  http_status: number
  http_body: string
  last_dispatched_to: string
  last_dispatched_from: string
  retry_attempts: number
  retry_reasons: CppIoRetryReason[]
}

export interface CppTxnOperationFailed extends CppErrorBase {
  ctxtype: 'transaction_operation_failed'
  should_not_retry: boolean
  should_not_rollback: boolean
  cause: CppTxnExternalException
}

export interface CppTxnError extends CppErrorBase {
  ctxtype: 'transaction_exception'
  result: CppTransactionResult
  cause: CppTxnExternalException
  type: CppTxnFailureType
}

export type CppError =
  | CppGenericError
  | CppKeyValueError
  | CppViewError
  | CppQueryError
  | CppSearchError
  | CppAnalyticsError
  | CppHttpError
  | CppTxnOperationFailed
  | CppTxnError

export interface CppConnection extends CppConnectionAutogen {
  connect(
    connStr: string,
    credentials: {
      username?: string
      password?: string
      certificate_path?: string
      key_path?: string
      allowed_sasl_mechanisms?: string[]
    },
    callback: (err: CppError | null) => void
  ): void
  shutdown(callback: (err: CppError | null) => void): void

  openBucket(bucketName: string, callback: (err: CppError | null) => void): void

  diagnostics(
    options: {
      report_id?: string
    },
    callback: (
      err: CppError | null,
      result: {
        version: number
        id: string
        sdk: string
        services: {
          [serviceType: number]: {
            type: CppServiceType
            id: string
            last_activity: number
            remote: string
            local: string
            state: CppDiagEndpointState
            bucket?: string
            details?: string
          }[]
        }
      }
    ) => void
  ): void

  ping(
    options: {
      report_id?: string
      bucket_name?: string
      services?: CppServiceType[]
    },
    callback: (
      err: CppError | null,
      result: {
        version: number
        id: string
        sdk: string
        services: {
          [serviceType: number]: {
            type: CppServiceType
            id: string
            latency: number
            remote: string
            local: string
            state: CppDiagPingState
            bucket?: string
            error?: string
          }[]
        }
      }
    ) => void
  ): void
}

export interface CppTransactionsConfig {
  durability_level?: CppProtocolDurabilityLevel
  kv_timeout?: CppMilliseconds
  expiration_time?: CppMilliseconds
  query_scan_consistency?: CppQueryScanConsistency
  cleanup_window?: CppMilliseconds
  cleanup_lost_attempts?: boolean
  cleanup_client_attempts?: boolean
}

export interface CppTransactionOptions {
  durability_level?: CppProtocolDurabilityLevel
  kv_timeout?: CppMilliseconds
  expiration_time?: CppMilliseconds
  query_scan_consistency?: CppQueryScanConsistency
}

export interface CppTransactionLinks {
  atr_id: string
  atr_bucket_name: string
  atr_scope_name: string
  atr_collection_name: string
  staged_transaction_id: string
  staged_attempt_id: string
  staged_content: string
  cas_pre_txn: string
  revid_pre_txn: string
  exptime_pre_txn: number
  crc32_of_staging: string
  op: string
  forward_compat: string
  is_deleted: boolean
}

export interface CppTransactionGetMetaData {
  cas: string
  revid: string
  exptime: number
  crc32: string
}

export interface CppTransactionGetResult {
  id: CppDocumentId
  cas: CppCas
  content: CppJsonString
  links: CppTransactionLinks
  metadata: CppTransactionGetMetaData
}

export interface CppTransactionResult {
  transaction_id: string
  unstaging_complete: boolean
}

export interface CppTransactions {
  new (conn: CppConnection): any

  close(callback: (err: CppError | null) => void): void
}

export interface CppTransaction {
  newAttempt(callback: (err: CppError | null) => void): void

  get(
    options: {
      id: CppDocumentId
    },
    callback: (
      err: CppError | null,
      result: CppTransactionGetResult | null
    ) => void
  ): void

  insert(
    options: {
      id: CppDocumentId
      content: CppJsonString
    },
    callback: (
      err: CppError | null,
      result: CppTransactionGetResult | null
    ) => void
  ): void

  replace(
    options: {
      doc: CppTransactionGetResult
      content: CppJsonString
    },
    callback: (
      err: CppError | null,
      result: CppTransactionGetResult | null
    ) => void
  ): void

  remove(
    options: {
      doc: CppTransactionGetResult
    },
    callback: (err: CppError | null) => void
  ): void

  query(
    statement: string,
    options: {
      raw?: { [key: string]: CppJsonString }
      ad_hoc?: boolean
      scan_consistency?: CppQueryScanConsistency
      profile?: CppQueryProfileMode
      metrics?: boolean
      client_context_id?: string
      scan_wait?: CppMilliseconds
      readonly?: boolean
      scan_cap?: number
      pipeline_batch?: number
      pipeline_cap?: number
      max_parallelism?: number
      positional_parameters?: CppJsonString[]
      named_parameters?: { [key: string]: CppJsonString }
      bucket_name?: string
      scope_name?: string
    },
    callback: (err: CppError | null, resp: CppQueryResponse | null) => void
  ): void

  commit(
    callback: (err: CppError | null, resp: CppTransactionResult) => void
  ): void

  rollback(callback: (err: CppError | null) => void): void
}

export interface CppBinding extends CppBindingAutogen {
  cbppVersion: string

  Connection: {
    new (): CppConnection
  }

  Transactions: {
    new (conn: CppConnection, config: CppTransactionsConfig): CppTransactions
  }

  Transaction: {
    new (txns: CppTransactions, options: CppTransactionOptions): CppTransaction
  }

  protocol_lookup_in_request_body_doc_flag: {
    access_deleted: number
  }
  protocol_lookup_in_request_body_lookup_in_specs_path_flag: {
    xattr: number
  }
  protocol_mutate_in_request_body_doc_flag: {
    mkdoc: number
    add: number
    access_deleted: number
    create_as_deleted: number
    revive_document: number
  }
  protocol_mutate_in_request_body_mutate_in_specs_path_flag: {
    create_parents: number
    xattr: number
    expand_macros: number
  }

  txn_failure_type: {
    fail: CppTxnFailureType
    expiry: CppTxnFailureType
    commit_ambiguous: CppTxnFailureType
  }
  txn_external_exception: {
    unknown: CppTxnExternalException
    active_transaction_record_entry_not_found: CppTxnExternalException
    active_transaction_record_full: CppTxnExternalException
    active_transaction_record_not_found: CppTxnExternalException
    document_already_in_transaction: CppTxnExternalException
    document_exists_exception: CppTxnExternalException
    document_not_found_exception: CppTxnExternalException
    not_set: CppTxnExternalException
    feature_not_available_exception: CppTxnExternalException
    transaction_aborted_externally: CppTxnExternalException
    previous_operation_failed: CppTxnExternalException
    forward_compatibility_failure: CppTxnExternalException
  }
}

// Load it with require
const binding: CppBinding = bindings('couchbase_impl')
export default binding
